﻿UseSQLiteDatabase()

Enumeration
  #pan
  #ca
  #fo
  #cpu
  #sf1
  #sf2
EndEnumeration

Procedure.l AddTooltip(Gadget, Tooltext$, maxW) 
  ;--> Remove the #TTS_BALLOON flag in the next line if you want the rectangular Tooltip 
  hToolTip = CreateWindowEx_(0, "ToolTips_Class32", "", #TTS_NOPREFIX | #TTS_BALLOON, 0, 0, 0, 0, 0, 0, GetModuleHandle_(0), 0) 
  SendMessage_(hToolTip, #TTM_SETTIPTEXTCOLOR, GetSysColor_(#COLOR_INFOTEXT), 0) 
  SendMessage_(hToolTip, #TTM_SETTIPBKCOLOR, GetSysColor_(#COLOR_INFOBK), 0) 
  ttAdd.TOOLINFO\cbSize = SizeOf(TOOLINFO) 
  ttAdd\uFlags = #TTF_SUBCLASS | #TTF_IDISHWND 
  ;--> Here's where the multiline comes into play by setting the maxWidth 
  SendMessage_(hToolTip, #TTM_SETMAXTIPWIDTH, 0, maxW) 
  ttAdd\hWnd = WindowID(0)
  ttAdd\uId = GadgetID(Gadget) 
  ttAdd\hinst = 0 
  ttAdd\lpszText = @Tooltext$ 
  SendMessage_(hToolTip, #TTM_ADDTOOL, 0, ttAdd) 
  SendMessage_(hToolTip, #TTM_SETDELAYTIME, #TTDT_AUTOPOP, 15000) 
  SendMessage_(hToolTip, #TTM_UPDATE , 0, 0) 
  ProcedureReturn hToolTip
EndProcedure 

Procedure.l RemoveToolTip(hTT.l, Gadget.l) 
  ttRemove.TOOLINFO\cbSize = SizeOf(TOOLINFO) 
  ttRemove\hWnd = WindowID(0) 
  ttRemove\uId = GadgetID(Gadget) 
  SendMessage_(hTT, #TTM_DELTOOL, 0, ttRemove) 
EndProcedure 

Procedure.l ChangeToolTip(hTT.l, Gadget.l, Tooltext$) 
  ttChange.TOOLINFO\cbSize = SizeOf(TOOLINFO) 
  ttChange\hWnd = WindowID(0) 
  ttChange\uId = GadgetID(Gadget) 
  ttChange\lpszText = @Tooltext$
  SendMessage_(hTT, #TTM_UPDATETIPTEXT, 0, ttChange) 
EndProcedure 


Procedure draw256c()
  StartDrawing(CanvasOutput(#ca))
  Box(0,0,522,532,$FFFFFF)
  For y=0 To 15
    For x=0 To 15
      n=x+y*16
      c=RGB( PeekA(?color256+n*3),PeekA(?color256+n*3+1),PeekA(?color256+n*3+2) )
      Box(x*32,y*32,31,31,c)
    Next x
  Next y
  
  StopDrawing()
EndProcedure

Procedure drawfont()
  StartDrawing(CanvasOutput(#fo))
  Box(0,0,522,532,0)
  For y=0 To 15
    For x=0 To 15
      n=x+y*16
      For i=0 To 7 ;y
        b=128
        If n&128
          a=255!PeekA(?font+(n&127)*8+i)
        Else
          a=PeekA(?font+n*8+i)
        EndIf
        For j=0 To 7 ;x
          If a&b
            c=RGB(97,174,253)
          Else
            c=RGB(1,78,157)
          EndIf
          Box(x*32+j*4,y*32+i*4,4,4,c)
          b>>1
        Next j
      Next i
    Next x
  Next y
  
  StopDrawing()
  
EndProcedure

Procedure refreshop()
  sql.s="select * from cpu"
  co1.s=GetGadgetText(#sf1)
  co2.s=GetGadgetText(#sf2)
  cond.s=""
  If co1<>""
    cond=" where opcode like'"+co1+"%'"
  EndIf
  
  If co2<>""
    If cond<>""
      cond=cond+" and mnem like '"+co2+"%'"
    Else
      cond=" where mnem like'"+co2+"%'"
    EndIf
  EndIf
  
  sql=sql+cond+" order by opcode asc"
  
  ;sql.s="select * from cpu"
  If DatabaseQuery(0,sql)
    ClearGadgetItems(#cpu)
    While NextDatabaseRow(0)
      r$=GetDatabaseString(0,1)+" "+GetDatabaseString(0,0)+GetDatabaseString(0,2)
      a=GetDatabaseLong(0,3)
      Select a
        Case 00:at.s="";00
        Case 01:at.s="(ind,X)";01
        Case 02:at.s="zpg"    ;02
        Case 03:at.s="#"      ;03
        Case 04:at.s="A"      ;04
        Case 05:at="(ind)"    ;05
        Case 06:at="abs"      ;06
        Case 07:at="rel"      ;07
        Case 08:at="(ind),Y"  ;08
        Case 09:at="zpg,X"    ;09
        Case 10:at="zpg,Y"    ;10
        Case 11:at="abs,Y"    ;11
        Case 12:at="abs,X"    ;12
        Default: at="???"
      EndSelect
      r$=r$+" "+at
      AddGadgetItem(#cpu,-1,r$)
    Wend
  Else
    Debug DatabaseError()
    Debug sql
  EndIf
  
EndProcedure

Procedure.a intrnl2Atascii(intr.a)
  atas.a=0
  intrnl.a=intr&127
  Select intrnl
    Case 0 To 63
      atas=intrnl+32
    Case 64 To 95
      atas=intrnl-64
    Case 96 To 127
      atas=intrnl
  EndSelect
  ;?inverse?
  ProcedureReturn atas|(intr&128)
EndProcedure

If OpenWindow(0, 0, 0, 520, 542, "Atari book 2.0", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  PanelGadget(#pan, 0, 0, 520, 542)
  AddGadgetItem (#pan, -1, "colors")
  CanvasGadget(#ca,0,0,522,542,#PB_Canvas_ClipMouse)
  hcaTT.l = AddTooltip(#ca, "This is"+#CRLF$+"a multiline Tooltip"+#CRLF$+"For the ButtonGadget", 200) 
  AddGadgetItem (#pan, -1, "charset")
  CanvasGadget(#fo,0,0,520,536)
  hfoTT.l = AddTooltip(#fo, "charset", 200) 
  AddGadgetItem (#pan, -1, "6502")
  ListIconGadget(#cpu,0,20,512,512-20,"Opcode",510-2)
  StringGadget(#sf1,0,0,40,20,"",#PB_String_UpperCase):GadgetToolTip(#sf1,"enter opcode # for filter")
  StringGadget(#sf2,40,0,80,20,"",#PB_String_UpperCase):GadgetToolTip(#sf2,"enter mnemonics for filter")
  CloseGadgetList()
  
  ;SetGadgetState(#pan, 2)
  draw256c()
  drawfont()
  
  resf=AddFontMemResourceEx_(?fn_b,?fn_e-?fn_b,0,@Fonts.l)
  LoadFont(1,"Atari 8-Bit Graphics",14)
  SetGadgetFont(#cpu,FontID(1))
  SetGadgetFont(#sf1,FontID(1))
  SetGadgetFont(#sf2,FontID(1))
  
  If OpenDatabase(0, ":memory:", "", "", #PB_Database_SQLite)
    If DatabaseUpdate(0, "Create Table cpu(undoc text,opcode text,mnem text,adrmode integer)")
      
      For i=0 To 255
        u$=PeekS(?cpu+i*5+4,1,#PB_Ascii)
        m$=PeekS(?cpu+i*5,3,#PB_Ascii)
        ad$=Str(PeekA(?cpu+i*5+3))
        If DatabaseUpdate(0, "insert into cpu (undoc,opcode,mnem,adrmode) values('"+u$+"','"+RSet(Hex(i),2,"0")+"','"+m$+"','"+ad$+"')")
        Else
          Debug DatabaseError()
          Break
        EndIf
        
      Next i
    Else
      Debug DatabaseError()
    EndIf
  Else
    Debug "err"
  EndIf
  
  refreshop()
  
  newx1=-1
  newy1=-1
  
  newx2=-1
  newy2=-1

  Repeat
    Event = WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)&32768
      Break
    EndIf
    Select Event
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #fo
            If EventType() = #PB_EventType_MouseMove
              ;  Debug "mouse"
              cx = GetGadgetAttribute(#fo, #PB_Canvas_MouseX)
              cy = GetGadgetAttribute(#fo, #PB_Canvas_MouseY)
              If cx>=0 And cy>=0
                If cx<>newx2 Or newy2<>cy
                  n=(cx>>5)+((cy>>5)<<4)
                  ChangeToolTip(hfoTT, #fo, "Screen Code:"+Str(n)+#CRLF$+"ATASCII:"+Str(intrnl2Atascii(n)))
                  newx2=cx
                  newy2=cy
                EndIf
              EndIf
            EndIf

          Case #ca
            If EventType() = #PB_EventType_MouseMove
              ;  Debug "mouse"
              cx = GetGadgetAttribute(#ca, #PB_Canvas_MouseX)
              cy = GetGadgetAttribute(#ca, #PB_Canvas_MouseY)
              If cx>=0 And cy>=0
                If cx<>newx1 Or newy1<>cy
                  n=(cx>>5)+((cy>>5)<<4)
                  ChangeToolTip(hcaTT, #ca, "color #:"+Str(n)+#CRLF$+"R:"+Str( PeekA(?color256+n*3) )+#CRLF$+"G:"+Str( PeekA(?color256+n*3+1) )+#CRLF$+"B:"+Str( PeekA(?color256+n*3+2) ) )
                  newx1=cx
                  newy1=cy
                EndIf
              EndIf
            EndIf
          Case #sf1,#sf2:
            If EventType()=#PB_EventType_Change
              refreshop()
            EndIf
        EndSelect
    EndSelect
    
  Until Event = #PB_Event_CloseWindow
EndIf

RemoveFontMemResourceEx_(resf)
DataSection
  color256:
  IncludeBinary "OlivierN.act"
  
  font:
  IncludeBinary "standard.fnt"
  
  cpu:
  IncludeBinary "mnemf_2.txt"
  
  fn_b:
  IncludeBinary "ATARI.FON"
  fn_e:
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 156
; FirstLine = 151
; Folding = --
; EnableXP
; UseIcon = atabook.ico
; Executable = atabook.exe